package edu.uoc.dtorrens.dtblib.dialeg;


import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import edu.uoc.dtorrens.dtblib.R;
import edu.uoc.dtorrens.dtblib.dialeg.exceptions.DialegException;

public abstract class Dialeg 
//extends AlertDialog 
{
	private static final String TAG = Dialeg.class.getName();
	
	public static final int RETURN_CODE_EXEMPLE = 0; 
	public static final int RETURN_CODE_IMATGE_PICKER = 1;
	public static final int RETURN_CODE_FILES_DIR = 2;
	public static final int RETURN_CODE_NOTA = 3;
	public static final int RETURN_CODE_SAVE = 4;
	
	/**
	 */
	protected int returnCode;
	
	/**
	 */
	protected int intOk;
	/**
	 */
	protected int intCancel;
	
	/**
	 */
	protected DialegListenerActivity context;
	//Flags
	public static final int ENABLE_ALL_BUTTONS = 0x1;
	public static final int ENABLE_BUTTON_OK = 0x2;
	public static final int ENABLE_BUTTON_CANCEL = 0x4;
	
	/**
	 */
	protected AlertDialog.Builder builder;
	/**
	 */
	protected final View root;
	
	//els valors
	/**
	 */
	protected boolean complete = false;
	/**
	 */
	protected Object [] results;
	
	/**
	 */
	protected AlertDialog dialeg;
	
	
	public Dialeg(DialegListenerActivity ctx)
	{
		context = ctx;
		root =null;
		
		context.setDialeg( this );
		
		builder = new AlertDialog.Builder(context);		
				
		build();
		
		dialeg = builder.create();
		
		builder.show();
	}
		/**
	 * 
	 * @param context
	 * @param layout
	 * @param view
	 */
	public Dialeg(DialegListenerActivity ctx,int layout) throws DialegException
	{
		context = ctx;
		
		context.setDialeg( this );
		
		LayoutInflater inflater = (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		root = inflater.inflate(layout,null);
		
		try{
			checkForm();
		}catch(DialegException e)
		{
			throw e;
		}
		
		builder = new AlertDialog.Builder(context);		
		builder.setView(root);
				
		build();
		
		dialeg = builder.create();
		
		builder.show();
	}
		
	protected abstract void build();
	
	
	protected void setButtons(int flags)
	{
		if( (flags &  Dialeg.ENABLE_ALL_BUTTONS )  == Dialeg.ENABLE_ALL_BUTTONS ||
				(flags & Dialeg.ENABLE_BUTTON_OK) ==  Dialeg.ENABLE_BUTTON_OK )
		{
			Log.i(TAG, " BT OK ") ;
			builder.setPositiveButton(R.string.ok, new DialogInterface.OnClickListener() {
		        public void onClick(DialogInterface dialog, int id) {
		            // Send the positive button event back to the host activity
		            Log.d(TAG, " Has clicat OK ");
		            
		            complete = true;
		            getResults();
		            context.onDialegReturn(results,returnCode);
		        }
		    });
		}else{
			Log.i(TAG, "NO BT OK ") ;
		}
		
		if( (flags &  Dialeg.ENABLE_ALL_BUTTONS )  == Dialeg.ENABLE_ALL_BUTTONS ||
				(flags & Dialeg.ENABLE_BUTTON_CANCEL) ==  Dialeg.ENABLE_BUTTON_CANCEL )
		{
			Log.i(TAG, " BT CANNCEL ") ;
		    builder.setNegativeButton(R.string.cancel, new DialogInterface.OnClickListener() {
		        public void onClick(DialogInterface dialog, int id) {
		        	Log.d(TAG, " Has clicat Cancelar ");
		        	complete = false;
		        	getResults();
		        	context.onDialegReturn(results, returnCode);
		        }
		    });
		}else{
			Log.i(TAG, "NO BT CANCEL") ;
		}
	}
	
	/**
	 * Chack form
	 */
	protected void checkForm() throws DialegException
	{
		if(root instanceof ViewGroup)
		{
			Log.i(TAG, "Arrel :: " + ((ViewGroup) root).getClass()) ;
			int n = ((ViewGroup) root).getChildCount();
			for( int i = 0; i < n; i++ )
			{
				Log.i(TAG, "Fill :: " + ((ViewGroup) root).getChildAt(i).getClass() );
			}
		}else{
			throw new DialegException("Layout must Have a viewGroup root");
		}
		
		
	}
	
	protected abstract void getResults();	
	
	public abstract void onActivityResult(int requestCode, int resultCode, Intent imageReturnedIntent);
}
