package edu.uoc.dtorrens.dtblib.dialeg;

import java.io.File;

import android.content.Intent;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Spinner;
import android.widget.TextView;
import edu.uoc.dtorrens.dtblib.R;
import edu.uoc.dtorrens.dtblib.dialeg.exceptions.DialegException;
import edu.uoc.dtorrens.dtblib.storage.StorageHelper;

public class DialegFilesDir extends Dialeg {

	private static final String TAG = DialegFilesDir.class.getName();
	
	/**
	 */
	private StorageHelper storage;
	/**
	 */
	private File[] files;
	/**
	 */
	private String[] fileNames;
	/**
	 */
	private int storageType;
	/**
	 */
	private Spinner spinner;
	//private ListView llista;
	/**
	 */
	private TextView msg;
	
	
	
	public DialegFilesDir(DialegListenerActivity ctx, StorageHelper sh, int st) throws DialegException 
	{
		super(ctx,R.layout.files_dialeg);		
		storage = sh;
		storageType = st;
		returnCode = Dialeg.RETURN_CODE_FILES_DIR;
		fillSpinner();
	}

	@Override
	protected void build() 
	{	
		msg = (TextView)root.findViewById(R.id.msg_dialeg_arxius);
		//llista = (ListView)root.findViewById(R.id.llista_dialeg_arxius);
		spinner = (Spinner)root.findViewById(R.id.llista_dialeg_arxius);
		
		
		if( storageType == StorageHelper.STORAGE_PRIVATE )
		{
			setButtons(Dialeg.ENABLE_ALL_BUTTONS);
		}else{
			setButtons(Dialeg.ENABLE_ALL_BUTTONS);
		}
	}

	protected void fillSpinner()
	{
		if( storageType == StorageHelper.STORAGE_PRIVATE )
		{
			files = storage.getPrivateCurrentDirContents();
			fileNames = storage.getPrivateCurrentDirContentsNames();
		}else{
			files = storage.getPublicCurrentDirContents();
			fileNames = storage.getPublicCurrentDirContentsNames();
		}
		
		if( files.length > 0 )
		{
			ArrayAdapter<String> arxius_adapter = new ArrayAdapter<String>(context,
									android.R.layout.simple_list_item_1, android.R.id.text1,
								fileNames);
			
			msg.setText(R.string.tria_un_arxiu);
			/*llista.setAdapter(arxius_adapter);			
			llista.setVisibility(View.VISIBLE);*/
			spinner.setAdapter(arxius_adapter);
			spinner.setVisibility(View.VISIBLE);
		}else{
			
			msg.setText(R.string.sense_arxiu);
			spinner.setVisibility(View.INVISIBLE);				
			//llista.setVisibility(View.INVISIBLE);
		}
	}
	
	@Override
	protected void getResults() 
	{
		results = new Object[3];
		results[0] = Boolean.valueOf(complete);
		if(complete && files.length > 0)
		{
			int i = spinner.getSelectedItemPosition();
			//int i = llista.getSelectedItemPosition();
			results[1] = (File)files[i];	        
		}else{
			results[0] = Boolean.valueOf(false);
			results[1] = null;
	        
		}
        
		if( context == null )
		{
			Log.e(TAG,"NULL EL Context");
		}else if(results == null)
		{
			Log.e(TAG,"NULL EL el results");
		}
	}

	@Override
	public void onActivityResult(int requestCode, int resultCode,
			Intent imageReturnedIntent) {
		// TODO Auto-generated method stub

	}

}
