package edu.uoc.dtorrens.dtblib.dialeg;

import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.util.Log;
import android.widget.Toast;
import edu.uoc.dtorrens.dtblib.R;
import edu.uoc.dtorrens.dtblib.dialeg.exceptions.DialegException;
import edu.uoc.dtorrens.dtblib.imatge.CameraPicker;
import edu.uoc.dtorrens.dtblib.imatge.GaleriaPicker;
import edu.uoc.dtorrens.dtblib.imatge.ImatgePickerInterface;


public class DialegImatgePicker extends Dialeg 
{
	private static final String TAG = DialegImatgePicker.class.getName(); 
	
	/**
	 */
	private int seleccio = -1;
	
	/**
	 */
	private ImatgePickerInterface ip;

	/**
	 */
	private Bitmap bitmap;
	
	/**
	 */
	private DialogInterface dialog_interface;
	
	public DialegImatgePicker(DialegListenerActivity context) throws DialegException 
	{
		super(context);
		returnCode = Dialeg.RETURN_CODE_IMATGE_PICKER;
	}

	@Override
	protected void build()
	{
			
			
			String[] texts = new String[]
					{
						context.getString(R.string.de_la_galeria),
						context.getString(R.string.de_la_camera),
					};
			
			
			builder.setTitle(context.getText(R.string.tria_una_imatge).toString());
			builder.setItems(texts, new android.content.DialogInterface.OnClickListener(){

				@Override
				public void onClick(DialogInterface dialog, int which) {
					Log.i(TAG, "Has triat : " + which);
					seleccio = which;	
					complete = true;
					getImage();
					dialog_interface = dialog;
					
				}});
	            
			
			
			setButtons(Dialeg.ENABLE_BUTTON_CANCEL);
	}

	
	
	@Override
	protected void getResults() 
	{
		results = new Object[2];
		
		if( seleccio != 0 && seleccio != 1  &&  complete )
		{
			results[0] = Boolean.valueOf(false);
			results[1] = null;
			Toast.makeText(context, "Has de triar una font per la imatge", Toast.LENGTH_LONG).show();
		}else if(complete){
				if( bitmap != null )
				{
					Log.i(TAG, "BITMAP NO NULL ");	
					results[0] = Boolean.valueOf(true);
					results[1] = bitmap;
				}else
				{
					Log.e(TAG, "BITMAP NULL ");
					Log.i(TAG,"Image Picker cancelat");
					results[0] = Boolean.valueOf(false);
					results[1] = null;
				}			
				
		}else if(!complete){
			Log.i(TAG,"Image Picker cancelat");
			results[0] = Boolean.valueOf(false);
			results[1] = null;
		}
	}

	public void getImage()
	{
		if( seleccio == 0 )
		{
			Log.i(TAG, "Has triat galeria ");
			ip = new GaleriaPicker(context);
		}else{
			Log.i(TAG, "Has triat càmara ");
			ip = new CameraPicker(context);
		}
		ip.startIntent();			
	}
	
	public void onActivityResult(int requestCode, int resultCode, Intent imageReturnedIntent)
	{
		bitmap = ip.getImatge(requestCode,resultCode,imageReturnedIntent);
		getResults();
		context.onDialegReturn(results, Dialeg.RETURN_CODE_IMATGE_PICKER);
		dialog_interface.dismiss();
	}
}
