package edu.uoc.dtorrens.dtblib.imatge;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.provider.MediaStore;
import android.util.Log;
import edu.uoc.dtorrens.dtblib.storage.StorageHelper;

public class CameraPicker extends ImatgePicker 
{

	private static final String TAG = GaleriaPicker.class.getName();
	
	
	public static final int INTENT_CODE = 2;
	
	/**
	 */
	public String imageTempPath;
	/**
	 */
	File tempImage;
	/**
	 */
	Uri imatgeUri;
	/**
	 */
	StorageHelper storage;
	
	public CameraPicker(Context ctx) {
		super(ctx);		
		storage = new StorageHelper(ctx);
	}

	@Override
	public void startIntent() 
	{
		Intent in = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
		
		//un nom provisional
		String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss", Locale.getDefault()).format(new Date());
		String imageTempName = "tmpimg_" + timeStamp + "_";
		
		try {
			
			tempImage = File.createTempFile(
					imageTempName, ".jpg", context.getExternalCacheDir() );
			
			//tempImage.deleteOnExit();		//no furul.la massa bé
			 
		    Log.i(TAG,"Imatge temporal :: " + tempImage.getAbsolutePath());
			
		    imageTempPath = tempImage.getAbsolutePath();
			
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		if( tempImage.exists() && tempImage.isFile() && tempImage.canWrite() )
		{
			in.putExtra(MediaStore.EXTRA_OUTPUT, Uri.fromFile(tempImage));
			((Activity)context).startActivityForResult(in, CameraPicker.INTENT_CODE);
		}else{
			Log.e(TAG, "L'arxiu NO és vàlid");			
		}
		
		
	}

	@Override
	public Bitmap getImatge(int requestCode, int resultCode,
			Intent imageReturnedIntent) 
	{
		
		Log.i(TAG, "Comparo :: " + requestCode + "==" + CameraPicker.INTENT_CODE + "&&" + resultCode + "==" + Activity.RESULT_OK );
		if(requestCode == CameraPicker.INTENT_CODE && resultCode == Activity.RESULT_OK) 
		{
			//torna el thumbnail
			//Bundle extras = imageReturnedIntent.getExtras();
            //return (Bitmap) extras.get("data");
			
			
			File img = new File(this.imageTempPath);
	        imatgeUri = Uri.fromFile(img);
			
	        Log.i(TAG,"IMATGE GAL " + imatgeUri);
	        if( imatgeUri != null )
	        {
	        	Log.i(TAG,"LA IMATGE NOOOOOO ÉS NULL!!!!");
	        	Bitmap temp = BitmapFactory.decodeFile(imageTempPath);
	        	//borro l'arxiu temporal
	        	if( img.delete() )
	        	{
	        		Log.i(TAG, "Arxiu temporal borrat ?");
	        		if( !img.exists() )
	        		{
	        			Log.i(TAG, "Si!!");
	        		}
	        	}
	        	return temp;
	        	
	        }else{
	        	Log.e(TAG,"LA IMATGE ÉS NULL!!!!");
	        	return null;
	        }
        	
		}
		return null;
	}

}
