package edu.uoc.dtorrens.dtblib.imatge;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.provider.MediaStore;
import android.util.Log;
import edu.uoc.dtorrens.dtblib.R;

public class GaleriaPicker extends ImatgePicker
{
	

	private static final String TAG = GaleriaPicker.class.getName();
	public static final int INTENT_CODE = 1;
	
	public GaleriaPicker(Context ctx) 
	{
		super(ctx);		
	}
	
	
	@Override
	public void startIntent() 
	{
		Intent in = new Intent(Intent.ACTION_GET_CONTENT);
		in.setType("image/*");
		
		((Activity)context).startActivityForResult(Intent.createChooser(in,
                context.getResources().getString(R.string.tria_de_la_galeria)),GaleriaPicker.INTENT_CODE);
		
	}

	@Override
	public Bitmap getImatge(int requestCode, int resultCode, Intent imageReturnedIntent) 
	{
		if(requestCode == GaleriaPicker.INTENT_CODE && resultCode == Activity.RESULT_OK) 
		{
	        Uri imatgeUri = imageReturnedIntent.getData();
	        Log.i(TAG,"IMATGE GAL " + imatgeUri);
	        if( imatgeUri != null )
	        {
	        	Log.i(TAG,"LA IMATGE NOOOOOO ÉS NULL!!!!");
	        	String[] filePathColumn = {MediaStore.Images.Media.DATA};
	            Cursor cursor = context.getContentResolver().query(imatgeUri, filePathColumn, null, null, null); 
	            cursor.moveToFirst();
	            int columnIndex = cursor.getColumnIndex(filePathColumn[0]);
	            String filePath = cursor.getString(columnIndex);
	            cursor.close();
	            return BitmapFactory.decodeFile(filePath);	        	
	        	
	        }else{
	        	Log.e(TAG,"LA IMATGE ÉS NULL!!!!");
	        	return null;
	        }
        	
		}
		return null;
	}

}
