package edu.uoc.dtorrens.dtblib.kml;

import java.io.IOException;
import java.io.InputStream;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

import android.util.Log;

public class KmlHandler 
{
	private static final String TAG = KmlHandler.class.getName();
	
	/**
	 */
	private KmlDataSet kmlDataSet;
	
	public KmlHandler()
	{
		kmlDataSet = null;
	}
	
	public void parse(InputStream in) throws ParserConfigurationException, SAXException, IOException
	{
		// create the factory
        SAXParserFactory factory = SAXParserFactory.newInstance();
        // create a parser
        SAXParser parser = factory.newSAXParser();
        // create the reader (scanner)
        XMLReader xmlreader = parser.getXMLReader();
        // instantiate our handler
        KmlSaxHandler kmlSaxHandler = new KmlSaxHandler();
        // assign our handler
        xmlreader.setContentHandler(kmlSaxHandler);
        
        if( in == null )
        {
        	Log.e(TAG,"in és NULL");
        }
        
        try
        {
        	InputSource is = new InputSource(in );
        	//is.setEncoding("UTF-8");
        	xmlreader.parse(is);
        }catch(Exception e)
        {
        	Log.e(TAG,"XMLREADER CAGADA: " + e.getMessage());
        	throw new IOException(e.getMessage());
        }finally{
        	in.close();
        }
        
        
        // get the results - should be a fully populated RSSFeed instance, or null on error
        kmlDataSet = kmlSaxHandler.getParsedData();
	}
	
	/**
	 * @return
	 */
	public KmlDataSet getKmlDataSet()
	{
		return kmlDataSet;
	}
}
