package edu.uoc.dtorrens.dtblib.kml;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import android.util.Log;

public class KmlSaxHandler extends DefaultHandler 
{
	private static final String TAG = KmlSaxHandler.class.getName();
	 // =========================================================== 
	 // Camps
	 // =========================================================== 

	 /**
	 */
	private boolean in_kmltag = false; 
	 /**
	 */
	private boolean in_placemarktag = false; 
	 /**
	 */
	private boolean in_nametag = false;
	 /**
	 */
	private boolean in_descriptiontag = false;
	 /**
	 */
	private boolean in_geometrycollectiontag = false;
	 /**
	 */
	private boolean in_linestringtag = false;
	 /**
	 */
	private boolean in_pointtag = false;
	 /**
	 */
	private boolean in_coordinatestag = false;
	 /**
	 */
	private boolean in_documenttag = false;
	 /**
	 */
	private boolean in_extendeddata = false;
	 /**
	 */
	private boolean in_data = false;
	 /**
	 */
	private boolean in_value = false;
	 /**
	 */
	private boolean is_dataimatge = false;
	 
	 //---------------------
	 /**
	 */
	private StringBuffer buffer = new StringBuffer();
	 
	 //private StringBuffer currentCoordBuffer = new StringBuffer();
	 
	 /**
	 */
	private KmlDataSet kmlDataSet = new KmlDataSet();
	 
	 //----------------------------------------------------
	 // GETTER & SETTER
	 public KmlDataSet getParsedData()
	 {
		//kmlDataSet.getMarcadorActual().setCoordenades( buffer.toString().trim() );
		return kmlDataSet;
	 }
	 
	 //-----------------------
	 // mètodes
	 public void startDocument() throws SAXException	 
	 {
		 this.kmlDataSet = new KmlDataSet();
		 //buffer = new StringBuffer();
	 }
	 
	 /*public void endDocument() throws SAXException
	 {
		 //rian de rian
	 }*/
	
	 /**
	  * Es crida quan troba tags d'obertura: <tag>
	  * Pot proveir atributs quan l'xml és de la forma
	  * <tag atribut="valor_de_l_atribut">
	  */
	 
	 public void startElement( String namespaceUri, String localName,
			 					String qName, Attributes atts) throws SAXException
		{
		 	if (localName.equalsIgnoreCase("kml"))
		 	{
		 		this.in_kmltag = true;
		 	}else if (localName.equalsIgnoreCase("Placemark"))
		 	{
		 		this.in_placemarktag = true;
		 		buffer = new StringBuffer();
		 		kmlDataSet.setMarcadorActual(new Marcador());
		 		
		 	}else if (localName.equalsIgnoreCase("name"))
		 	{
		 		this.in_nametag= true;
		 	}else if (localName.equalsIgnoreCase("description"))
		 	{
		 		this.in_descriptiontag = true;
		 	}else if (localName.equalsIgnoreCase("GeometryCollection"))
		 	{
		 		this.in_geometrycollectiontag = true;
		 	}else if (localName.equalsIgnoreCase("LineString"))
		 	{
		 		this.in_linestringtag = true;
		 	}else if (localName.equalsIgnoreCase("point"))
		 	{
		 		this.in_pointtag= true;
		 	}else if (localName.equalsIgnoreCase("coordinates"))
		 	{
		 		this.in_coordinatestag = true;
		 	}else if (localName.equalsIgnoreCase("Document"))
		 	{
		 		this.in_documenttag = true;
		 	}else if (localName.equalsIgnoreCase("ExtendedData"))
		 	{
		 		this.in_extendeddata = true;
		 	}else if (localName.equalsIgnoreCase("Data"))
		 	{
		 		this.in_data = true;
		 		if( atts.getLength() > 0 )
		 		{
		 			Log.i(TAG,"TENIM Atributs");
		 			for(int i = 0; i < atts.getLength(); i++ )
		 			{
		 				if( atts.getQName(i).equalsIgnoreCase("name") && atts.getValue(i).equalsIgnoreCase("imatge") )
		 				{
		 					this.is_dataimatge = true;
		 				}
		 			}
		 			
		 		}
		 	}else if (localName.equalsIgnoreCase("value"))
		 	{
		 		this.in_value = true;
		 	}
		}	 
	 
	 /**
	  * Es crida quan troba tags de tancament: </tag>
	  */
	 
	 /* public void endElement( String namespaceUri, String localName,
			 					String qName, Attributes atts) throws SAXException*/
		public void endElement( String namespaceUri, String localName,
					 					String qName) throws SAXException
		{
		 	if (localName.equalsIgnoreCase("kml"))
		 	{
		 		this.in_kmltag = false;
		 	}else if (localName.equalsIgnoreCase("Placemark"))
		 	{
		 		this.in_placemarktag = false;	
		 		
		 		kmlDataSet.getMarcadorActual().setCoordenades( buffer.toString().trim() );
		 		
		 		//if("Route".equalsIgnoreCase(kmlDataSet.getMarcadorActual().getTitol()))
		 		if( kmlDataSet.getMarcadorActual().isRuta())
		 		{
		 			kmlDataSet.setMarcadorRuta( kmlDataSet.getMarcadorActual()  );
		 		}else{
		 			kmlDataSet.addMarcadorActual();
		 		}		 		
		 		
		 	}else if (localName.equalsIgnoreCase("name"))
		 	{
		 		this.in_nametag= false;
		 	}else if (localName.equalsIgnoreCase("description"))
		 	{
		 		this.in_descriptiontag = false;
		 	}else if (localName.equalsIgnoreCase("GeometryCollection"))
		 	{
		 		this.in_geometrycollectiontag = false;
		 	}else if (localName.equalsIgnoreCase("LineString"))
		 	{
		 		//dtb
		 		kmlDataSet.getMarcadorActual().setTipus(Marcador.TIPUS_RUTA);
		 		//dtb
		 		this.in_linestringtag = false;
		 	}else if (localName.equalsIgnoreCase("point"))
		 	{
		 		this.in_pointtag= false;
		 	}else if (localName.equalsIgnoreCase("coordinates"))
		 	{
		 		this.in_coordinatestag = false;
		 	}else if (localName.equalsIgnoreCase("Document"))
		 	{
		 		this.in_documenttag = false;
		 	}else if (localName.equalsIgnoreCase("ExtendedData"))
		 	{
		 		this.in_extendeddata = false;
		 	}else if (localName.equalsIgnoreCase("Data"))
		 	{
		 		this.in_data = false;
		 	}else if (localName.equalsIgnoreCase("value"))
		 	{
		 		this.in_value = false;
		 	}
		}
	 
	 /**
	  * Es crida entre tags d'obertura i tancament 
	  */
	 public void characters(char ch[], int start, int length)
	 {
		 if(this.in_nametag){ 
			 if( this.in_placemarktag )
			 {
			        if (kmlDataSet.getMarcadorActual()==null) kmlDataSet.setMarcadorActual(new Marcador());
			        kmlDataSet.getMarcadorActual().setTitol(new String(ch, start, length));
			 }
		    } else 
		    if(this.in_descriptiontag){ 
		    	if( this.in_placemarktag )
				 {
		    		if (kmlDataSet.getMarcadorActual()==null) kmlDataSet.setMarcadorActual(new Marcador());
		    		kmlDataSet.getMarcadorActual().setDescripcio(new String(ch, start, length));
				 }
		    } else
		    if(this.in_coordinatestag){    
		    	if( this.in_placemarktag )
				 {
				        if (kmlDataSet.getMarcadorActual()==null) kmlDataSet.setMarcadorActual(new Marcador());
				        //navigationDataSet.getCurrentPlacemark().setCoordinates(new String(ch, start, length));
				        buffer.append(ch, start, length);
				 }
		    }else
			    if(this.in_data){    
			    	if( this.is_dataimatge )
					 {
					        if (kmlDataSet.getMarcadorActual()==null) kmlDataSet.setMarcadorActual(new Marcador());
					        kmlDataSet.getMarcadorActual().setTipus(Marcador.TIPUS_IMATGE);
					        String imatge = new String(ch, start, length);
					        Log.i(TAG, "SET Imatge :: " + imatge);
					        kmlDataSet.getMarcadorActual().setImatge(imatge);
					 }
			    }
	 }
}
