package edu.uoc.dtorrens.dtblib.localitzacio;

import android.app.ActionBar.OnNavigationListener;
import android.location.Criteria;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;

import com.google.android.gms.maps.LocationSource;

import edu.uoc.dtorrens.dtblib.kml.KmlDataSet;
import edu.uoc.dtorrens.dtblib.mapes.MapaInterface;

public class MapsDosLocation implements OnNavigationListener, 
										LocationSource,
										LocationListener
										
{
	private static final String TAG = MapsDosLocation.class.getName();
	
	public static final String BRODCAST_PASAPAS = "edu.uoc.dtorrens.dtblib.action.LOCATION_UPDATE";
	private static final int SERVEI_ID = 1;
	
	private static final int INTERVAL = 1000;
	private static final float DISTANCIA = 10f;
	
	/**
	 */
	private MapaInterface mapInt;
	
	/**
	 */
	private OnLocationChangedListener mapLocationListener=null;
	/**
	 */
	private LocationManager locMngr = null;
	/**
	 */
	private Criteria crit = new Criteria();
	
	/**
	 */
	private KmlDataSet objKml;
	/**
	 */
	private boolean gravant = false;
	
	/**
	 */
	private Location currentLocation;
	
	/**
	 */
	private int tipus;
	
	
	public MapsDosLocation(MapaInterface m)
	{
		mapInt = m;
		
		//override LocationListener
		
		//fi location listener overrrides
	}

	public void setMapInterface(MapaInterface mapa)
	{
		mapInt = mapa;
	}
	
	public void forceLastKnownLocation()
	{
		Location gps_location = locMngr.getLastKnownLocation(LocationManager.GPS_PROVIDER);
 		Location network_location = locMngr.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);
 		if ( gps_location!=null && network_location != null )
 		{
	 		if( LocationUtils.isBetterLocation(gps_location, network_location))
	 		{
	 			Log.i(TAG,"Best last known GPS");
	 			currentLocation = new Location(gps_location);
	 		}else{
	 			Log.i(TAG,"Best last known NETWORK");
	 			currentLocation = new Location(network_location);
	 		}
	 		
	 		onLocationChanged(currentLocation);
 		}else{
 			if(gps_location == null)
 			{
 				Log.i(TAG,"GPS_LOCATION NULL" );
 			}
 			
 			if(network_location == null)
 			{
 				Log.i(TAG,"NETWORK_LOCATION NULL" );
 			}
 		}
	}
	
		//LOCATION V
		// OVERRIDES LocationListener
		
			
			
			
			
			@Override
			public void onLocationChanged(Location location) {
				 if (mapLocationListener != null) {
				      mapLocationListener.onLocationChanged(location);
				      
				      if(currentLocation == null)
				      {
				    	  currentLocation = new Location(location);
				      }else{
				      	currentLocation.set(location);
				      }
				      
				      mapInt.onLocationChangeCallback(location,this);
				      
				    }
			}
	
			@Override
			public void onProviderDisabled(String arg0) {
			
				// TODO Auto-generated method stub
				
			}
	
			@Override
			public void onProviderEnabled(String arg0) {
		
				// TODO Auto-generated method stub
				
			}
	
			@Override
			public void onStatusChanged(String provider, int status, Bundle extras) {
				// TODO Auto-generated method stub
				
			}
		
		
		@Override
		public void activate(OnLocationChangedListener listener) {
			// TODO Auto-generated method stub
			this.mapLocationListener=listener;
			
		}

		@Override
		public void deactivate() {
			// TODO Auto-generated method stub
			this.mapLocationListener=null;
			
		}

		@Override
		public boolean onNavigationItemSelected(int arg0, long arg1) {
			// TODO Auto-generated method stub
			return false;
		}

		// DANI 
		public LocationManager getLocationManager()
		{
			return locMngr;
		}
		
		public void setLocationManager(LocationManager l)
		{
			locMngr = l; 
		}
		
		public Criteria getCriteria()
		{
			return crit;
		}
		
		public void setCriteria(Criteria c)
		{
			crit = c;
		}
		
		public KmlDataSet getKmlDataSet()
		{
			return objKml;
		}
		
		public void setKmlDataSet(KmlDataSet d)
		{
			objKml = d;
		}
		
		/**
		 * @param t
		 */
		public void setTipus(int t)
		{
			tipus = t;
		}
		
		/**
		 * @return
		 */
		public int getTipus()
		{
			return tipus;
		}
}
