package edu.uoc.dtorrens.dtblib.localitzacio;

import android.location.Location;
import android.location.LocationListener;
import android.os.Bundle;
import edu.uoc.dtorrens.dtblib.mapes.MapaInterface;

public class SimpleLocationListener implements LocationListener {

	/**
	 */
	public double lat;
	/**
	 */
	public double lon;	
	/**
	 */
	public MapaInterface mapa;
	/**
	 */
	Location currentLocation;
	/**
	 */
	Location currentBestLocation;
	
	//30 segons
	/**
	 */
	private final int TIME_DELAY = 1000 * 30;  
	
	public SimpleLocationListener(MapaInterface m)
	{
		mapa = m;
	}
	
	@Override
	public void onLocationChanged(Location loc) 
	{
		if( loc != null)
		{
			lat = loc.getLatitude();
			lon = loc.getLongitude();
			mapa.centrar(lat,lon);
		}

	}

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onProviderEnabled(String provider) {
		// TODO Auto-generated method stub

	}

	@Override
	public void onProviderDisabled(String provider) {
		// TODO Auto-generated method stub

	}

	//Utils from Google Android dev docs
	/** Checks whether two providers are the same */
	private boolean isSameProvider(String provider1, String provider2) {
	    if (provider1 == null) {
	      return provider2 == null;
	    }
	    return provider1.equals(provider2);
	}
	
	/** Determines whether one Location reading is better than the current Location fix
	  * @param location  The new Location that you want to evaluate
	  * @param currentBestLocation  The current Location fix, to which you want to compare the new one
	  */
	protected boolean isBetterLocation(Location location, Location currentBestLocation) {
	    if (currentBestLocation == null) {
	        // A new location is always better than no location
	        return true;
	    }

	    // Check whether the new location fix is newer or older
	    long timeDelta = location.getTime() - currentBestLocation.getTime();
	    boolean isSignificantlyNewer = timeDelta > TIME_DELAY;
	    boolean isSignificantlyOlder = timeDelta < -TIME_DELAY;
	    boolean isNewer = timeDelta > 0;

	    // If it's been more than two minutes since the current location, use the new location
	    // because the user has likely moved
	    if (isSignificantlyNewer) {
	        return true;
	    // If the new location is more than two minutes older, it must be worse
	    } else if (isSignificantlyOlder) {
	        return false;
	    }

	    // Check whether the new location fix is more or less accurate
	    int accuracyDelta = (int) (location.getAccuracy() - currentBestLocation.getAccuracy());
	    boolean isLessAccurate = accuracyDelta > 0;
	    boolean isMoreAccurate = accuracyDelta < 0;
	    boolean isSignificantlyLessAccurate = accuracyDelta > 200;

	    // Check if the old and new location are from the same provider
	    boolean isFromSameProvider = isSameProvider(location.getProvider(),
	            currentBestLocation.getProvider());

	    // Determine location quality using a combination of timeliness and accuracy
	    if (isMoreAccurate) {
	        return true;
	    } else if (isNewer && !isLessAccurate) {
	        return true;
	    } else if (isNewer && !isSignificantlyLessAccurate && isFromSameProvider) {
	        return true;
	    }
	    return false;
	}
}
