package edu.uoc.dtorrens.dtblib.mapes;

import java.io.File;

import android.location.Criteria;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.widget.ImageView;
import android.widget.TextView;
import edu.uoc.dtorrens.dtblib.R;
import edu.uoc.dtorrens.dtblib.dialeg.Dialeg;
import edu.uoc.dtorrens.dtblib.dialeg.DialegFilesDir;
import edu.uoc.dtorrens.dtblib.dialeg.exceptions.DialegException;
import edu.uoc.dtorrens.dtblib.storage.StorageHelper;

public class MapPlay extends AbstractBaseMap 
{
	/**
	 */
	private final String TAG = MapPlay.class.getName();
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.play_screen);
		
		tv = (TextView)findViewById(R.id.txt_missatges);
		tv.setText(getResources().getString(R.string.buscant_posicio));
		
		itv = (TextView)findViewById(R.id.image_overlay_info);
		iv = (ImageView)findViewById(R.id.imatge_overlay);
		iv.setOnTouchListener(new OnTouchListener(){

			@Override
			public boolean onTouch(View v, MotionEvent event) 
			{
				v.setVisibility(View.GONE);
				itv.setVisibility(View.GONE);
				return true;
			}});
	
		
		storage = new StorageHelper(this);
		storage.addFilter(".kml");
		storage.addFilter(".KML");
		storage.addFilter(".prz");
		storage.addFilter(".PRZ");
		storage.setPublicDir(StorageHelper.publicDirName);
		//primer hem d'escollir un arxiu
		try {
			new DialegFilesDir(this, storage, StorageHelper.STORAGE_PUBLIC);
		} catch (DialegException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		this.context = this;
		
		mapLocation.setLocationManager( (LocationManager)getSystemService(LOCATION_SERVICE) );
	 	mapLocation.getCriteria().setAccuracy(Criteria.ACCURACY_FINE);
		
		init();
		
		
		
	}

	public void onDestroy()
	{
		storage.currentPrivateToRoot();
		storage.createPrivateSubdir(StorageHelper.tempDir);
		File dir = new File( storage.getPrivateCurrentDir() );
		storage.borraRecursiu(dir);
		
		super.onDestroy();
	}
	
	//---------------------------
	// Inicialitzacions


	@Override
	public void onDialegReturn(Object[] result, int code) {
		Log.i(TAG,"Dialegs Callback");
		if( result != null )
		{		
			if((Boolean) result[0] )
			{
				switch(code)
				{
					
					case Dialeg.RETURN_CODE_FILES_DIR:
						if( result[1] != null )
						{
							File file = (File)result[1];
							if( file.getName().endsWith(".kml") || file.getName().endsWith(".KML") )
							{
								Log.i(TAG, "HEM REBUT UN KML");
								drawKmlFromFile(  file.getAbsolutePath() );
							}else if( file.getName().endsWith(".prz") || file.getName().endsWith(".PRZ") ){
								Log.i(TAG,"Hem rebut un PRZ");
								
								storage.currentPrivateToRoot();
								storage.createPrivateSubdir(StorageHelper.tempDir);
								storage.saveToDirZip(file.getAbsolutePath());
								
								drawKmlFromFile(  storage.getPrivateCurrentDir() + "/ruta.kml" );
								storage.createPrivateSubdir(StorageHelper.imageDir);
								
								
							}else{
								Log.i(TAG,"Hem rebut un desconegut");
							}
						}						
						
						break;					
					default:
						Log.e(TAG,"RETURN CODE NOT DEFINED");
						break;
				}
			}else{
				Log.i(TAG,"Dialeg Canceled or Error");
				this.finish();
			}
		}
		
	}
	
	// OVERRIDE
	public void onFitListener(View v)
	{
		gravant = true;
		super.onFitListener(v);
		gravant=false;
	}
	
}