package edu.uoc.dtorrens.dtblib.mapes;

import java.io.FileNotFoundException;

import android.graphics.Bitmap;
import android.location.Criteria;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import edu.uoc.dtorrens.dtblib.R;
import edu.uoc.dtorrens.dtblib.dialeg.Dialeg;
import edu.uoc.dtorrens.dtblib.dialeg.DialegGuarda;
import edu.uoc.dtorrens.dtblib.dialeg.DialegImatgePicker;
import edu.uoc.dtorrens.dtblib.dialeg.DialegListenerActivity;
import edu.uoc.dtorrens.dtblib.dialeg.DialegNota;
import edu.uoc.dtorrens.dtblib.dialeg.exceptions.DialegException;
import edu.uoc.dtorrens.dtblib.kml.KmlDataSet;
import edu.uoc.dtorrens.dtblib.kml.Marcador;
import edu.uoc.dtorrens.dtblib.storage.StorageHelper;

public class MapTrack extends AbstractBaseMap 
{
	/**
	 */
	private final String TAG = MapTrack.class.getName();
		
	//Botons
	/**
	 */
	ImageButton bt_rec;
	/**
	 */
	ImageButton bt_stop;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.track_screen_main);
		
		tv = (TextView)findViewById(R.id.txt_missatges);
		tv.setText(getResources().getString(R.string.buscant_posicio));
		
		bt_rec = (ImageButton)findViewById(R.id.bt_rec_pausa);
		bt_stop = (ImageButton)findViewById(R.id.bt_stop);
		
		itv = (TextView)findViewById(R.id.image_overlay_info);
		iv = (ImageView)findViewById(R.id.imatge_overlay);
		iv.setOnTouchListener(new OnTouchListener(){

			@Override
			public boolean onTouch(View v, MotionEvent event) 
			{
				v.setVisibility(View.GONE);
				itv.setVisibility(View.GONE);
				return true;
			}});
		
		storage = new StorageHelper(this);
		
		this.context = this;
		
		mapLocation.setLocationManager( (LocationManager)getSystemService(LOCATION_SERVICE) );
	 	mapLocation.getCriteria().setAccuracy(Criteria.ACCURACY_FINE);
		
		init();
		
	}

	
	

	
	//---------- BUTTON CALLBACKS
	public void onRecListener(View v)
	{
		if(currentLocation != null)
		{
			Log.i(TAG, "HAS CLICAT REC I CURENT LOCATION != NULL ");
			objKml = new KmlDataSet();
			
			Marcador marc = new Marcador();
			marc.setCoordenada(currentLocation.getLatitude(), currentLocation.getLongitude());
			marc.setTitol( getResources().getString(R.string.marc_origen) );
			marc.setTipus(Marcador.TIPUS_ORIGEN);
			
			objKml.setMarcadorActual(marc);
			objKml.addMarcadorActual();
			
			Marcador ruta = new Marcador();
			marc.appendCoordenada(currentLocation.getLatitude(), currentLocation.getLongitude());
			objKml.setMarcadorRuta(ruta);
			
			gravant = true;
			
			drawKmlDataSet(objKml);
			
			v.setVisibility(View.GONE);
			bt_stop.setVisibility(View.VISIBLE);
		}else{
			Log.i(TAG, "HAS CLICAT REC I CURENT LOCATION == NULL ");
			Toast.makeText(context, R.string.err_no_location, Toast.LENGTH_LONG).show();
		}
	}
	
	public void onStopListener(View v)
	{
		Log.d(TAG," STOP LISTENER");
		gravant = false;
		
		try
    	{
    		new DialegGuarda((DialegListenerActivity)context);
    	}catch(DialegException e)
    	{
    		Log.d(TAG, "Error :: " + e.getMessage());
    	}
	}

	public void onCamListener(View v)
	{
		if(!gravant)
		{
			Toast.makeText(context, getText(R.string.alert_imatge_sense_gravar).toString(), Toast.LENGTH_LONG).show();
			return;
		}
		try
    	{
    		new DialegImatgePicker((DialegListenerActivity)context);
    	}catch(DialegException e)
    	{
    		Log.d(TAG, "Error :: " + e.getMessage());
    	}
	}
	
	public void onMsgListener(View v)
	{
		if(!gravant)
		{
			Toast.makeText(context, getText(R.string.alert_nota_sense_gravar).toString(), Toast.LENGTH_LONG).show();
			return;
		}
		try
    	{
    		new DialegNota((DialegListenerActivity)context);
    	}catch(DialegException e)
    	{
    		Log.d(TAG, "Error :: " + e.getMessage());
    	}
	}
	
	
	
	//------ GESTIÓ DE DIÀLEGS
	@Override
	public void onDialegReturn(Object[] result, int code) 
	{
		Log.i(TAG,"Dialegs Callback");
		if( result != null )
		{		
			if((Boolean) result[0] )
			{
				switch(code)
				{
					case Dialeg.RETURN_CODE_SAVE: 
						
						String info = "";
						info += "Titol : " + (String)result[1];
						info += "\ndescripcio : " + (String)result[2];
						info += "\nnom_arxiu : " + (String)result[3];
						
						Log.i(TAG," SAVE REBUT ::  " + info);
						
						//poso el marcador de destí
						Marcador marc = new Marcador();
						marc.setCoordenada(currentLocation.getLatitude(), currentLocation.getLongitude());
						marc.setTitol( getResources().getString(R.string.marc_desti) );
						marc.setTipus(Marcador.TIPUS_DESTI);
						
						objKml.setMarcadorActual(marc);
						objKml.addMarcadorActual();
						
						objKml.setTitol((String)result[1]);
						objKml.setDescripcio((String)result[2]);
						
						//i el punt a la ruta
						objKml.getMarcadorRuta().appendCoordenada(currentLocation.getLatitude(), currentLocation.getLongitude());
						
						//guardo el kml
						storage.currentPrivateToRoot();
						storage.createPrivateSubdir(StorageHelper.tempDir);
						this.saveKml("ruta.kml", storage.getPrivateCurrentDir());
						
						storage.saveToZipDir((String)result[3] + ".prz");
						
						// netegem el rastre
						cleanObjKml();
						
						//torno a pinta perquè desaparegui tot
						//drawKmlDataSet(objKml);
						mapa.clear();
						
						bt_stop.setVisibility(View.GONE);
						bt_rec.setVisibility(View.VISIBLE);
						Toast.makeText(context, R.string.arxiu_guardat, Toast.LENGTH_LONG).show();
						this.finish();
						
						break;
					case Dialeg.RETURN_CODE_NOTA: 
						String msg = "";
						msg += "Titol : " + (String)result[1];
						msg += "\nMsg : " + (String)result[2];
						
						Log.i(TAG," MISSATGE REBUT ::  " + msg);
						
						Marcador marc_msg = new Marcador();
						marc_msg.setTipus(Marcador.TIPUS_NOTA);
						marc_msg.setTitol((String)result[1]);
						marc_msg.setDescripcio((String)result[2]);
						marc_msg.setCoordenada(currentLocation.getLatitude(), currentLocation.getLongitude());
						
						objKml.setMarcadorActual(marc_msg);
						objKml.addMarcadorActual();
						
						drawKmlDataSet(objKml);
						break;
					case Dialeg.RETURN_CODE_IMATGE_PICKER:
						Bitmap bitmap =  (Bitmap)result[1];
						
						//guardo la imatge
						// 1 . creo el directory si no existeix
						storage.currentPrivateToRoot();
						storage.createPrivateSubdirNotExists(StorageHelper.imageDir);
						try {
							storage.currentPrivateToRoot();
							storage.createPrivateSubdir(StorageHelper.tempDir);
							storage.createPrivateSubdir(StorageHelper.imageDir);
							Log.i(TAG,"Estem al dir private :: " + storage.getPrivateCurrentDir());
							String nomArxiu = StorageHelper.imageName + imageCount + ".png";
							storage.saveBitmapCurrentPrivateDir(bitmap, nomArxiu  );
							
							Marcador marc_desti = new Marcador();
							marc_desti.setTipus(Marcador.TIPUS_IMATGE);
							marc_desti.setImatge(nomArxiu);
							marc_desti.setCoordenada(currentLocation.getLatitude(), currentLocation.getLongitude());
							
							objKml.setMarcadorActual(marc_desti);
							objKml.addMarcadorActual();
							
							imageCount++;
							
							drawKmlDataSet(objKml);
						} catch (FileNotFoundException e) {
							e.printStackTrace();
						}
						
						
						break;
					/*case Dialeg.RETURN_CODE_FILES_DIR:
						if( result[1] != null )
						{
							File file = (File)result[1];
							if( file.getName().endsWith(".png") )
							{
								showImage( BitmapFactory.decodeFile(file.getAbsolutePath()) );
							}else if( file.getName().endsWith(".zip") ){
								Log.i(TAG,"Hem rebut un zip");
								//m'asseguro el dir
								sm.currentPrivateToRoot();
								sm.createPrivateSubdirNotExists(imageDir);
								sm.zipToDir(file.getAbsolutePath());
								Log.i(TAG,"Hem rebut un desconegut");
							}else{
								Log.i(TAG,"Hem rebut un desconegut");
							}
						}						
						
						break; */						
					default:
						Log.e(TAG,"RETURN CODE NOT DEFINED");
						break;
				}
			}else{
				Log.i(TAG,"Dialeg Canceled or Error");
			}
		}
	}
	
}
