package edu.uoc.dtorrens.dtblib.mapes.overlay;

import java.util.ArrayList;
import java.util.Iterator;

import android.app.AlertDialog;
import android.content.Context;
import android.graphics.drawable.Drawable;
import android.util.Log;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.OverlayItem;

import edu.uoc.dtorrens.dtblib.kml.Marcador;
import edu.uoc.dtorrens.dtblib.kml.Punt;

public class MapItemizedOverlay extends ItemizedOverlay<OverlayItem>
{
	/**
	 */
	private final String TAG = MapItemizedOverlay.class.getName();
	
    /**
	 */
    private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
    /**
	 */
    private Context mContext;

    /**
	 */
    private ArrayList<Marcador> marcadors = new ArrayList<Marcador>();
    
    public MapItemizedOverlay(Drawable defaultMarker, Context context) {
          super(boundCenterBottom(defaultMarker));
          mContext = context;
    }

    public void addOverlay(OverlayItem overlay) {
        mOverlays.add(overlay);
        populate();
    }

    @Override
    protected OverlayItem createItem(int i) {
      return mOverlays.get(i);
    }

    @Override
    public int size() {
      return mOverlays.size();
    }

    public void addMarcador(Marcador marcador)
    {
    	//marcadors.add(marcador);
    	
    	Iterator<Punt> it = marcador.getPunts().iterator();
    	if( it.hasNext() )
    	{
    		Punt p = it.next();
    		GeoPoint gp = new GeoPoint( Double.valueOf(p.getLatitud() * 1E6).intValue(), 
    									Double.valueOf(p.getLongitud() * 1E6 ).intValue() );
    	
    		OverlayItem item = new OverlayItem(gp, null, null );
            addOverlay(item);
            marcadors.add(marcador);
    	}else{
    		Log.e(TAG, "El marcador no té punts vàlids");
    	}
    }
    
    public boolean onTap(int index)
    {
    	if(!marcadors.isEmpty())
    	{
	    	Marcador marcador = marcadors.get(index);
	    	if(marcador != null)
	    	{
		    	AlertDialog.Builder dialog = new AlertDialog.Builder(mContext);
		    	dialog.setTitle(marcador.getTitol() + " :: " + index);
		    	dialog.setMessage(marcador.getDescripcio());
		    	dialog.show();
		    	return true;
	    	}
    	}
    	return false;
    }
}
