package edu.uoc.dtorrens.pasapas;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;
import edu.uoc.dtorrens.dtblib.storage.StorageHelper;

public class PasapasActivity extends Activity 
{


		/**
		 */
		Button bt_nou;
		/**
		 */
		Button bt_obre;
		
	    @Override
	    protected void onCreate(Bundle savedInstanceState) {
	        super.onCreate(savedInstanceState);
	        setContentView(R.layout.activity_inici);
	        
	        checkGPS();
	        
	        
	        //creo el directory per la App
	        StorageHelper sh = new StorageHelper(this);
	        sh.setPublicDir(StorageHelper.publicDirName);
	        
	        //buttons
	        bt_nou = (Button) findViewById(R.id.bt_nou_activity);
	        bt_nou.setOnClickListener(new View.OnClickListener() {
				
				@Override
				public void onClick(View v) {
					if(checkGPS())
					{
						Intent intent = new Intent(PasapasActivity.this, TrackScreenActivity.class);
						startActivity(intent);
					}
				}
			});
	        
	        bt_obre = (Button) findViewById(R.id.bt_obre_activity);
	        bt_obre.setOnClickListener(new View.OnClickListener() {
				
				@Override
				public void onClick(View v) {
					if(checkGPS())
					{
						Intent intent = new Intent(PasapasActivity.this, PlayRutaActivity.class);
						startActivity(intent);
					}
				}
			});
	        
	    }
	    
	    public void onResume()
	    {
	    	super.onResume();
	    	//checkGPS();
	    }
	    
	    /**
	     * Comprova si el GPS està habilitat
	     * @return boolean segons si el GPS està habilitat o no
	     */
	    private boolean checkGPS()
	    {
	    	LocationManager locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);

	    	if (locationManager.isProviderEnabled(LocationManager.GPS_PROVIDER)){
	    		Toast.makeText(this, getResources().getText(R.string.gps_disponible).toString(), Toast.LENGTH_SHORT).show();
	    		return true;
	    	}else{
	    		showGPSDisabledAlert();
	    		return false;
	    	}	    	
	    }
	    
	    private void showGPSDisabledAlert()
	    {
	    	
	    	AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(this);
	    	alertDialogBuilder.setMessage(getResources().getText(R.string.gps_no_disponible).toString())
	    			.setCancelable(false)
	    			.setPositiveButton(getResources().getText(R.string.a_gps_dialeg).toString(),
	    	new DialogInterface.OnClickListener()
	    	{
	    				public void onClick(DialogInterface dialog, int id)
	    				{
	    					dialog.dismiss();
	    					Intent callGPSSettingIntent = new Intent(
	    							android.provider.Settings.ACTION_LOCATION_SOURCE_SETTINGS);
	    							startActivity(callGPSSettingIntent);
	    					
	    				}
	    	});
	    	
	    	alertDialogBuilder.setNegativeButton(getResources().getText(R.string.bt_cancel).toString(),
	    			new DialogInterface.OnClickListener()
	    			{
	    				public void onClick(DialogInterface dialog, int id)
	    				{
	    							//dialog.cancel();
	    							dialog.dismiss();
	    							close();
	    				}
	    			});
	    	AlertDialog alert = alertDialogBuilder.create();
	    	alert.show();
	    }
	    
	    protected void close()
	    {
	    	this.finish();
	    }
}



